start_draw_splat:
  rep #$30   ;A=16, X/Y=16
  ldx #SplatRequestTable

  lda SplatRequestTableSlot::YPosition,x
  and #$0000000000000111
  asl
  bne continue_calculating_vertical_offset
  sta SplatSubTileYPosition

continue_calculating_vertical_offset:
  lda SplatRequestTableSlot::YPosition,x
  ror
  ror
  ror
  sep #$20	;A=8
  sta $4202
  lda DataPerRowInBuffer
  sta $4203	;Apparently, there's some sort of waiting time for this?
  rep #$30	;A=16, X/Y=16

  lda SplatRequestTableSlot::Height,x
  sta SplatFullTileHeight
  asl
  asl
  asl
  asl
  asl
  sta SplatDataHeight
  lda SplatRequestTableSlot::Width,x
  sta SplatTileWidth

  lda $4216
  sta SplatBufferPosition

;======================================================================

  lda SplatRequestTableSlot::XPosition,x
  and #%0000000000000111
  bne continue_calculating_x_offset
  inc SplatTileWidth
  lda SplatRequestTableSlot::XPosition,x
  and #%0000000000000111

  sep #$20	;A=8
  sta $4202
  lda SplatRequestTableSlot::GraphicDataSize,x
  sta $4203	;Apparently, there's some sort of waiting time for this?
  rep #$30	;A=16, X/Y=16

  lda SplatRequestTableSlot::XPosition,x
  ror
  ror
  and #%0011111111111111
  clc
  adc SplatBufferPosition
  sta SplatBufferPosition

  lda $4216
  sec
  sbc SplatDataHeight
continue_calculating_x_offset:
  clc
  adc SplatRequestTableSlot::GraphicOffset,x
  sta SplatGraphicOffset

  lda SplatSubTileYPosition
  asl
  tax
  jsr (VariableYOffsetCodeJumpTable,x)

;======================================================================

VariableYOffsetCodeJumpTable:
  .word start_draw_offset_3_splat,start_draw_offset_3_splat
  .word start_draw_offset_3_splat,start_draw_offset_3_splat
  .word start_draw_offset_3_splat,start_draw_offset_3_splat
  .word start_draw_offset_3_splat,start_draw_offset_3_splat

;======================================================================

start_draw_offset_3_splat:
  ldx SplatBufferPosition
  cpx EndOfBuffer
  bcc continue_draw_offset_3_splat
  rts

continue_draw_offset_3_splat:
  ldy SplatGraphicOffset
  lda SplatGraphicOffset
  clc
  adc #$0014
  sta SplatGraphicOffset

draw_offset_3_splat_first_rows:
  lda InkBuffer+6,x
  and $0000,y
  ora $0002,y
  sta InkBuffer+6,x

  lda InkBuffer+8,x
  and $0004,y
  ora $0006,y
  sta InkBuffer+8,x

  lda InkBuffer+10,x
  and $0008,y
  ora $000A,y
  sta InkBuffer+10,x

  lda InkBuffer+12,x
  and $000C,y
  ora $000E,y
  sta InkBuffer+12,x

  lda InkBuffer+14,x
  and $0010,y
  ora $0012,y
  sta InkBuffer+14,x

  inc TilesDrawnHorizontally
  cmp SplatTileWidth
  bcs start_draw_offset_3_splat_middle_rows
  txa
  clc
  adc #$0010
  tax
  tya
  clc
  adc SplatDataHeight
  tay
  bra draw_offset_3_splat_first_rows

;======================================================================

start_draw_offset_3_splat_middle_rows:
  ldx SplatBufferPosition
  stz TilesDrawnHorizontally
  txa
  clc
  adc DataPerRowInBuffer
  tax
  ldy SplatGraphicOffset

draw_offset_3_splat_middle_rows:
  lda InkBuffer,x
  and $0000,y
  ora $0002,y
  sta InkBuffer,x

  lda InkBuffer+2,x
  and $0004,y
  ora $0006,y
  sta InkBuffer+2,x

  lda InkBuffer+4,x
  and $0008,y
  ora $000A,y
  sta InkBuffer+4,x

  lda InkBuffer+6,x
  and $000C,y
  ora $000E,y
  sta InkBuffer+6,x

  lda InkBuffer+8,x
  and $0010,y
  ora $0012,y
  sta InkBuffer+8,x

  lda InkBuffer+10,x
  and $0014,y
  ora $0016,y
  sta InkBuffer+10,x

  lda InkBuffer+12,x
  and $0018,y
  ora $001A,y
  sta InkBuffer+12,x

  lda InkBuffer+14,x
  and $001C,y
  ora $001E,y
  sta InkBuffer+14,x

  lda FullTilesDrawnVertically
  cmp SplatFullTileHeight
  bcs start_draw_offset_3_splat_last_rows
  inc TilesDrawnHorizontally
  cmp SplatTileWidth
  bcs offset_3_splat_next_row
  txa
  clc
  adc #$0010
  tax
  tya
  clc
  adc SplatDataHeight
  tay
  bra draw_offset_3_splat_middle_rows

offset_3_splat_next_row:
  cpx EndOfBuffer
  bcs continue_offset_3_splat_next_row
  stz FullTilesDrawnVertically
  rts
  
continue_offset_3_splat_next_row:
  inc FullTilesDrawnVertically
  inc TilesDrawnHorizontally
  txa
  clc
  adc DataPerRowInBuffer
  tax
  lda SplatGraphicOffset
  clc
  adc #$0020
  sta SplatGraphicOffset
  tay
  brl draw_offset_3_splat_middle_rows

;======================================================================

start_draw_offset_3_splat_last_rows:
  ldx SplatBufferPosition
  cpx EndOfBuffer
  bcs draw_offset_3_splat_done
  stz TilesDrawnHorizontally
  txa
  clc
  adc DataPerRowInBuffer
  tax
  ldy SplatGraphicOffset

draw_offset_3_splat_last_rows:
  lda InkBuffer,x
  and $0000,y
  ora $0002,y
  sta InkBuffer,x

  lda InkBuffer+2,x
  and $0004,y
  ora $0006,y
  sta InkBuffer+2,x

  lda InkBuffer+4,x
  and $0008,y
  ora $000A,y
  sta InkBuffer+4,x

  inc TilesDrawnHorizontally
  cmp SplatTileWidth
  bcs continue_draw_offset_3_splat_last_rows
draw_offset_3_splat_done:
  stz FullTilesDrawnVertically
  rts
  
continue_draw_offset_3_splat_last_rows:
  txa
  clc
  adc #$0010
  tax
  tya
  clc
  adc SplatDataHeight
  tay
  bra draw_offset_3_splat_last_rows