;======================================================================
.segment "CODE"
;======================================================================

.proc Main
  InitializeSNES
  jsr InitializeControllers
  sep #$20	;A=8

  lda #%00000100		;Turn on BG3
  sta $212C

;Enable NMI	(when interrupts get re-enabled) and joypad reading
  lda #$81
  sta $4200

;Turn on screen, full brightness
  lda #$0F
  sta $2100

  cli		; Restore interrupts -- we're all ready to go!

  rep #$30	; A=16, X/Y=16

  lda #$0002
  sta ObjectTable

  lda #$0027
  sta SplatRequestTableSlot::XPosition
  lda #$0013
  sta SplatRequestTableSlot::YPosition
  lda #$0001
  sta SplatRequestTableSlot::Width
  sta SplatRequestTableSlot::Height
  lda #$00F0
  sta SplatRequestTableSlot::GraphicDataSize
  lda #SplatTiles
  sta SplatRequestTableSlot::GraphicOffset

  lda #$0040
  sta DataPerRowInBuffer
  lda #InkBufferSize
  sta EndOfBuffer
  jsr start_draw_splat

InfiniteLoop:
  wai
  jsr start_object_identifier
  jmp InfiniteLoop
.endproc

;======================================================================

.proc VBlank
  rep #$30	;A=16, X/Y=16
  pha
  phx
  phy
  phd
  phb
  php

  jsr GetControllerInput

  sep #$20	;A=8
  stz $2102			;set OAM address to 0
  stz $2103			;...and no priority rotation

  stz $4300			;CPU -> PPU, auto-increment, write once
  lda #$04
  sta $4301			;DMA will write to register $2104 (OAM data write)
  ldy #.LOWORD(SpriteBuf1)
  sty $4302			;source offset of SpriteBuf1
  lda #.BANKBYTE(SpriteBuf1)
  sta $4304			;bank address of SpriteBuf1
  ldy #$0220			;size of SpriteBuf1 + SpriteBuf2
  sty $4305			;transfer SpriteBufSize bytes (pre-calculated number)
  lda #$01
  sta $420B			;start DMA transfer

  lda $4210	;clear NMI Flag

  plp
  plb
  pld
  ply
  plx
  pla
  rti
.endproc