.setcpu "65816"
.smart

;======================================================================
.struct ObjectTableSlot

XPosition		.byte 3
YPosition		.byte 3
FlipBits		.byte 2
MetaspriteTableOffset	.byte 2

.endstruct
;======================================================================
.struct SplatRequestTableSlot

XPosition		.byte 2
YPosition		.byte 2
Width			.byte 2
Height			.byte 2
GraphicDataSize		.byte 2
GraphicOffset		.byte 2

.endstruct
;======================================================================
.segment "ZEROPAGE"
;======================================================================

ColorCounter:			.res 2

Joy1Data:			.res 2
Joy2Data:			.res 2
Joy1Press:			.res 2
Joy2Press:			.res 2
NewObjectRequest:		.res 2
ObjectOffset:			.res 2
SpriteCount:			.res 2
MetaspriteCount:		.res 2
HFlipMask:			.res 2
VFlipMask:			.res 2
MetaspriteAttributes:		.res 2
TilesDrawnHorizontally:		.res 2
FullTilesDrawnVertically:	.res 2
SplatBufferPosition:		.res 2
SplatSubTileYPosition:		.res 2
SplatGraphicOffset:		.res 2
SplatTileWidth:			.res 2
SplatFullTileHeight:		.res 2
SplatDataHeight:		.res 2
DataPerRowInBuffer:		.res 2
EndOfBuffer:			.res 2

;======================================================================
.segment "BSS"
;======================================================================

ObjectTableEntryNumber=	32
ObjectTableEntrySize=		.sizeof(ObjectTableSlot)
ObjectTable:			.res ObjectTableEntryNumber * ObjectTableEntrySize
ObjectTableSize=		*-ObjectTable
SpriteBuf1:			.res 512
SpriteBuf2:			.res 32
SpriteBuf3:			.res 512
SplatRequestTableEntryNumber=	1
SplatRequestTableEntrySize=	.sizeof(SplatRequestTableSlot)
SplatRequestTable:		.res SplatRequestTableEntryNumber * SplatRequestTableEntrySize
SplatRequestTableSize=		*-ObjectTable

;======================================================================
.segment "BSS7E"
;======================================================================

InkBuffer:			.res 14336
InkBufferSize=			*-InkBuffer

;======================================================================
.segment "BSS7F"
;======================================================================

;======================================================================
.segment "RODATA"
;======================================================================

SplatTiles:
  .include "SplatTiles.txt"

;======================================================================
.include "Header.asm"
.include "InitializeSNES.asm"
.include "InitializeControllers.asm"
.include "ObjectHandler.asm"
.include "ProcessOam.asm"
.include "Metasprite.asm"
.include "DrawSplat.asm"
.include "GameLoop.asm"

.include "Objects\Object1\Object1Code.asm"